module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId])
/******/ 			return installedModules[moduleId].exports;
/******/
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			exports: {},
/******/ 			id: moduleId,
/******/ 			loaded: false
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.loaded = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "/home/mseabra/botpress/botpress-waboxapp";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

	module.exports = __webpack_require__(1);


/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var _botpressVersionManager = __webpack_require__(2);
	
	var _botpressVersionManager2 = _interopRequireDefault(_botpressVersionManager);
	
	var _path = __webpack_require__(3);
	
	var _path2 = _interopRequireDefault(_path);
	
	var _fs = __webpack_require__(4);
	
	var _fs2 = _interopRequireDefault(_fs);
	
	var _lodash = __webpack_require__(5);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _bluebird = __webpack_require__(6);
	
	var _bluebird2 = _interopRequireDefault(_bluebird);
	
	var _waboxapp = __webpack_require__(7);
	
	var _waboxapp2 = _interopRequireDefault(_waboxapp);
	
	var _actions = __webpack_require__(12);
	
	var _actions2 = _interopRequireDefault(_actions);
	
	var _outgoing = __webpack_require__(13);
	
	var _outgoing2 = _interopRequireDefault(_outgoing);
	
	var _incoming = __webpack_require__(14);
	
	var _incoming2 = _interopRequireDefault(_incoming);
	
	var _umm = __webpack_require__(16);
	
	var _umm2 = _interopRequireDefault(_umm);
	
	var _botpressWaboxappConfig = __webpack_require__(18);
	
	var _botpressWaboxappConfig2 = _interopRequireDefault(_botpressWaboxappConfig);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var waboxapp = null; /* global __dirname */
	
	var outgoingPending = _outgoing2.default.pending;
	
	var outgoingMiddleware = function outgoingMiddleware(event, next) {
	  if (event.platform !== 'waboxapp') {
	    return next();
	  }
	
	  if (!_outgoing2.default[event.type]) {
	    return next('Unsupported event type: ' + event.type);
	  }
	
	  var setValue = function setValue(method) {
	    return function () {
	      for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
	        args[_key] = arguments[_key];
	      }
	
	      if (event.__id && outgoingPending[event.__id]) {
	
	        if (args && args[0] && args[0].message_id) {
	          outgoingPending[event.__id].timestamp = new Date().getTime() - 1000;
	          outgoingPending[event.__id].mid = args[0].message_id;
	        }
	
	        if (method === 'resolve' && (event.raw.waitDelivery || event.raw.waitRead)) {
	          // We skip setting this value because we wait
	        } else {
	          outgoingPending[event.__id][method].apply(null, args);
	          delete outgoingPending[event.__id];
	        }
	      }
	    };
	  };
	
	  _outgoing2.default[event.type](event, next, waboxapp).then(setValue('resolve'), setValue('reject'));
	};
	
	var initializeWaboxapp = function initializeWaboxapp(bp, configurator) {
	  return configurator.loadAll().then(function (config) {
	    waboxapp = new _waboxapp2.default(bp, config);
	
	    var configErrors = waboxapp.getConfigErrors();
	    var enabled = config.enabled;
	
	    if (!enabled) {
	      return bp.logger.warn('[botpress-waboxapp] Connection disabled.');
	    }
	
	    if (configErrors.length) {
	      var _iteratorNormalCompletion = true;
	      var _didIteratorError = false;
	      var _iteratorError = undefined;
	
	      try {
	        for (var _iterator = configErrors[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	          var err = _step.value;
	
	          bp.logger.warn('[botpress-waboxapp] ' + err.message);
	        }
	      } catch (err) {
	        _didIteratorError = true;
	        _iteratorError = err;
	      } finally {
	        try {
	          if (!_iteratorNormalCompletion && _iterator.return) {
	            _iterator.return();
	          }
	        } finally {
	          if (_didIteratorError) {
	            throw _iteratorError;
	          }
	        }
	      }
	
	      return bp.notifications.send({
	        level: 'error',
	        message: 'Error updating Waboxapp App. Please see logs for details.'
	      });
	    }
	  });
	};
	
	var createConfigFile = function createConfigFile(bp) {
	  var name = 'botpress-waboxapp.config.yml';
	  var file = _path2.default.join(bp.projectLocation, name);
	
	  if (!_fs2.default.existsSync(file)) {
	    _fs2.default.writeFileSync(file, _botpressWaboxappConfig2.default);
	
	    bp.notifications.send({
	      level: 'info',
	      message: name + ' has been created, fill it'
	    });
	  }
	};
	
	module.exports = {
	
	  config: {
	    phoneID: { type: 'string', required: true, default: '', env: 'WABOXAPP_PHONE_ID' },
	    accessToken: { type: 'string', required: true, default: '', env: 'WABOXAPP_ACCESS_TOKEN' },
	    enabled: { type: 'bool', required: true, default: true },
	    validated: { type: 'bool', required: false, default: false }, // deprecated --> automaticcaly reconfigure on start (config = enabled)
	    url: { type: 'string', required: false, default: '', env: 'HOST_URL' },
	    homepage: { type: 'string' }
	  },
	
	  init: function init(bp) {
	
	    (0, _botpressVersionManager2.default)(bp, __dirname);
	
	    bp.middlewares.register({
	      name: 'waboxapp.sendMessages',
	      type: 'outgoing',
	      order: 100,
	      handler: outgoingMiddleware,
	      module: 'botpress-waboxapp',
	      description: 'Sends out messages that targets platform = waboxapp.' + ' This middleware should be placed at the end as it swallows events once sent.'
	    });
	
	    bp.waboxapp = {};
	    _lodash2.default.forIn(_actions2.default, function (action, name) {
	
	      var applyFn = function applyFn(fn) {
	        return function () {
	          var msg = action.apply(this, arguments);
	          var promise = msg._promise;
	          return fn && fn(msg, promise);
	        };
	      };
	
	      var deprecate = function deprecate(fn) {
	        return function () {
	          return bp.lts && bp.lts.deprecate({
	            module: 'botpress-waboxapp',
	            message: 'create___ and send___ methods have been deprecated in favor of UMM and will be officially removed in Botpress v2.0',
	            referenceUrl: 'https://botpress.io/docs/foundamentals/umm.html'
	          }, fn) || fn.apply(this, arguments);
	        };
	      };
	
	      var sendName = name.replace(/^create/, 'send');
	      bp.waboxapp[sendName] = deprecate(_bluebird2.default.method(applyFn(function (msg, promise) {
	        return bp.middlewares.sendOutgoing(msg) && promise;
	      })));
	      bp.waboxapp[name] = deprecate(applyFn(function (msg) {
	        return msg;
	      }));
	    });
	
	    createConfigFile(bp);
	    (0, _umm2.default)(bp); // Initializes Messenger in the UMM
	  },
	
	  ready: function ready(bp, config) {
	    initializeWaboxapp(bp, config).then(function () {
	      (0, _incoming2.default)(bp, waboxapp);
	
	      bp.waboxapp._internal = waboxapp;
	
	      var router = bp.getRouter('botpress-waboxapp');
	
	      router.get('/config', function (req, res) {
	        res.send(waboxapp.getConfig());
	      });
	
	      router.post('/config', function (req, res) {
	        waboxapp.setConfig(req.body);
	        config.saveAll(waboxapp.getConfig()).then(function () {
	          return res.sendStatus(200);
	        }).catch(function (err) {
	          res.status(500).send({ message: err.message });
	        });
	      });
	
	      router.post('/validation', function (req, res) {
	        waboxapp.sendValidationRequest().then(function (json) {
	          res.send(json);
	        }).catch(function (err) {
	          res.status(500).send({ message: err.message });
	        });
	      });
	
	      router.get('/homepage', function (req, res) {
	        var packageJSON = JSON.parse(_fs2.default.readFileSync(_path2.default.join(__dirname, '../package.json')));
	        res.send({ homepage: packageJSON.homepage });
	      });
	    });
	  }
	};

/***/ }),
/* 2 */
/***/ (function(module, exports) {

	module.exports = require("botpress-version-manager");

/***/ }),
/* 3 */
/***/ (function(module, exports) {

	module.exports = require("path");

/***/ }),
/* 4 */
/***/ (function(module, exports) {

	module.exports = require("fs");

/***/ }),
/* 5 */
/***/ (function(module, exports) {

	module.exports = require("lodash");

/***/ }),
/* 6 */
/***/ (function(module, exports) {

	module.exports = require("bluebird");

/***/ }),
/* 7 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();
	
	function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
	
	function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }
	
	function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
	
	/**
	 * Waboxapp
	 *
	 * This file contains one class Waboxapp, which in charge of communication between
	 * botpress and waboxapp.
	 *
	 */
	
	var Promise = __webpack_require__(6);
	var EventEmitter = __webpack_require__(8);
	var crypto = __webpack_require__(9);
	var fetch = __webpack_require__(10);
	var _ = __webpack_require__(5);
	var bodyParser = __webpack_require__(11);
	
	fetch.promise = Promise;
	
	var normalizeString = function normalizeString(str) {
	  return str.replace(/[^a-zA-Z0-9]+/g, '').toUpperCase();
	};
	
	var Waboxapp = function (_EventEmitter) {
	  _inherits(Waboxapp, _EventEmitter);
	
	  function Waboxapp(bp, config) {
	    _classCallCheck(this, Waboxapp);
	
	    var _this = _possibleConstructorReturn(this, (Waboxapp.__proto__ || Object.getPrototypeOf(Waboxapp)).call(this));
	
	    if (!bp || !config) {
	      throw new Error('You need to specify botpress and config');
	    }
	
	    _this.setConfig(config);
	    _this.bp = bp;
	
	    _this.app = bp.getRouter('botpress-waboxapp', { auth: false });
	
	    _this._initWebhook();
	
	    return _this;
	  }
	
	  _createClass(Waboxapp, [{
	    key: 'setConfig',
	    value: function setConfig(config) {
	      this.config = Object.assign({}, this.config, config);
	    }
	  }, {
	    key: 'getConfig',
	    value: function getConfig() {
	      return this.config;
	    }
	  }, {
	    key: 'getConfigErrors',
	    value: function getConfigErrors() {
	      var errors = [];
	      var required = ['phoneID', 'accessToken', 'url'];
	
	      _.forEach(this.config, function (value, key) {
	        if (_.includes(required, key) && (_.isNil(value) || _.isEmpty(value))) {
	          errors.push({
	            key: key,
	            message: 'Configuration is incomplete, ' + key + ' needs to be defined. See "./botpress-waboxapp.config.yml".'
	          });
	        }
	      });
	
	      return errors;
	    }
	  }, {
	    key: 'sendTextMessage',
	    value: function sendTextMessage(recipientId, text, messageId) {
	
	      /*console.log(recipientId)
	      console.log(text)
	      console.log(messageId)*/
	      //const message = { text }
	      var message = text;
	
	      return this.sendMessage(recipientId, message, messageId);
	    }
	  }, {
	    key: 'sendMessage',
	    value: function sendMessage(recipientId, message, messageId) {
	      var _this2 = this;
	
	      /*console.log(recipientId)
	      console.log(message)
	      console.log(messageId)*/
	
	      var req = function req() {
	        return _this2.sendRequest(recipientId, message, messageId);
	      };
	
	      //console.log(recipientId||message||messageId)
	
	      /*if (options && options.typing) {
	        const autoTimeout = (message && message.text) ? 500 + message.text.length * 10 : 1000
	        const timeout = (typeof options.typing === 'number') ? options.typing : autoTimeout
	        return this.sendTypingIndicator(recipientId, timeout).then(req)
	      }*/
	
	      return req();
	    }
	  }, {
	    key: 'sendRequest',
	    value: function sendRequest(recipientId, message, messageId, endpoint, method) {
	      var _this3 = this;
	
	      /*console.log(recipientId)
	      console.log(message)
	      console.log(messageId)*/
	
	      endpoint = endpoint || 'send/chat';
	      method = method || 'POST';
	
	      var url = 'https://www.waboxapp.com/api/' + endpoint;
	      return fetch(url + '?token=' + this.config.accessToken + '&uid=' + this.config.phoneID + '&to=' + recipientId + '&custom_uid=' + messageId + '&text=' + message, {
	        method: method,
	        headers: { 'Content-Type': 'application/json' }
	      }).then(this._handleWaboxappResponse).then(function (res) {
	        return res.json();
	      }).then(function (json) {
	        _this3._handleEvent('raw_send_request', { url: url, token: _this3.config.accessToken, recipientId: recipientId, message: message, messageId: messageId, endpoint: endpoint, method: method, response: json });
	        return json;
	      });
	    }
	  }, {
	    key: 'sendThreadRequest',
	    value: function sendThreadRequest(body, method) {
	      return this.sendRequest(body, 'thread_settings', method);
	    }
	  }, {
	    key: 'module',
	    value: function module(factory) {
	      return factory.apply(this, [this]);
	    }
	  }, {
	    key: '_handleEvent',
	    value: function _handleEvent(type, event) {
	      this.emit(type, event);
	    }
	  }, {
	    key: '_handleMessageEvent',
	    value: function _handleMessageEvent(event) {
	      var text = event.message.text;
	      if (!text) {
	        return;
	      }
	
	      this._handleEvent('message', event);
	
	      if (event.message && this.config.automaticallyMarkAsRead) {
	        this.sendAction(event.sender.id, 'mark_seen');
	      }
	    }
	  }, {
	    key: '_handleWaboxappResponse',
	    value: function _handleWaboxappResponse(res) {
	      if (!res) return;
	
	      if (res.status < 400) {
	        return res;
	      }
	
	      var errorMessage = 'An error has been returned by Waboxapp API.';
	      errorMessage += '\nStatus: ' + res.status + ' (' + res.statusText + ')';
	
	      return Promise.resolve(true).then(function () {
	        return res.json();
	      }).then(function (json) {
	        errorMessage += '\n' + json.error.message;
	      }).finally(function () {
	        throw new Error(errorMessage);
	      });
	    }
	  }, {
	    key: '_initWebhook',
	    value: function _initWebhook() {
	      var _this4 = this;
	
	      this.app.use(bodyParser.json({}));
	
	      this.app.post('/webhook/', function (req, res) {
	        //if (_.includes(platforms, req.params.platform)) {
	        //var text = req.query['text'] ? req.query['text'] : '';
	        //var type = req.query['type'] ? req.query['type'] : 'default';
	        //console.log(req.body)
	        if (typeof req.body.contact !== "undefined") {
	          _this4.emit('webhook', {
	            body: req.body,
	            platform: 'waboxapp',
	            user: req.body.contact.uid,
	            text: req.body.message.body.text,
	            type: req.body.message.type
	          });
	          res.sendStatus(200);
	        }
	        /*} else {
	          res.sendStatus(404)
	        }*/
	      });
	    }
	  }]);
	
	  return Waboxapp;
	}(EventEmitter);
	
	module.exports = Waboxapp;

/***/ }),
/* 8 */
/***/ (function(module, exports) {

	module.exports = require("eventemitter2");

/***/ }),
/* 9 */
/***/ (function(module, exports) {

	module.exports = require("crypto");

/***/ }),
/* 10 */
/***/ (function(module, exports) {

	module.exports = require("node-fetch");

/***/ }),
/* 11 */
/***/ (function(module, exports) {

	module.exports = require("body-parser");

/***/ }),
/* 12 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var _lodash = __webpack_require__(5);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _bluebird = __webpack_require__(6);
	
	var _bluebird2 = _interopRequireDefault(_bluebird);
	
	var _outgoing = __webpack_require__(13);
	
	var _outgoing2 = _interopRequireDefault(_outgoing);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	var create = function create(obj) {
	  var resolve = null;
	  var reject = null;
	  var promise = new _bluebird2.default(function (r, rj) {
	    resolve = r;
	    reject = rj;
	  });
	
	  var messageId = new Date().toISOString() + Math.random();
	
	  var newEvent = Object.assign({
	    _promise: promise,
	    _resolve: resolve,
	    _reject: reject,
	    __id: messageId
	  }, obj);
	
	  _outgoing2.default.pending[messageId] = {
	    event: newEvent,
	    resolve: resolve,
	    reject: reject
	  };
	
	  return newEvent;
	};
	
	var validateUserId = function validateUserId(userId) {
	  if (!/[0-9]+/.test(userId)) {
	    throw new Error('Invalid userId');
	  }
	};
	
	var validateText = function validateText(text) {
	  if (typeof text !== 'string' || text.length > 640) {
	    throw new Error('Text must be a string less than 640 chars.');
	  }
	};
	
	var createText = function createText(userId, text, options) {
	  validateUserId(userId);
	  validateText(text);
	
	  return create({
	    platform: 'waboxapp',
	    type: 'text',
	    text: text,
	    raw: {
	      to: userId,
	      message: text
	    }
	  });
	};
	
	module.exports = {
	  createText: createText
	};

/***/ }),
/* 13 */
/***/ (function(module, exports) {

	'use strict';
	
	var handlePromise = function handlePromise(next, promise) {
	  return promise.then(function (res) {
	    next();
	    return res;
	  }).catch(function (err) {
	    next(err);
	    throw err;
	  });
	};
	
	var handleText = function handleText(event, next, waboxapp) {
	  return handlePromise(next, waboxapp.sendTextMessage(event.raw.to, event.raw.message, new Date().toISOString() + Math.random()));
	};
	
	module.exports = {
	  'text': handleText,
	  pending: {}
	};

/***/ }),
/* 14 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var _lruCache = __webpack_require__(15);
	
	var _lruCache2 = _interopRequireDefault(_lruCache);
	
	var _lodash = __webpack_require__(5);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	module.exports = function (bp, waboxapp) {
	
	  var messagesCache = (0, _lruCache2.default)({
	    max: 10000,
	    maxAge: 60 * 60 * 1000
	  });
	
	  /*const preprocessEvent = payload => {
	    const userId = payload.sender && payload.sender.id
	    const mid = payload.message && payload.message.mid
	     if (mid && !messagesCache.has(mid)) {
	      // We already processed this message
	      payload.alreadyProcessed = true
	    } else {
	      // Mark it as processed
	      messagesCache.set(mid, true)
	    }
	     return users.getOrFetchUserProfile(userId)
	  }*/
	
	  /*waboxapp.on('message', e => {
	    //preprocessEvent(e)
	    //.then(profile => {
	      // push the message to the incoming middleware
	      //console.log(e)
	      bp.middlewares.sendIncoming({
	        platform: 'waboxapp',
	        type: 'message',
	        user: e.contact,
	        text: e.message.text,
	        raw: e
	      })
	    //})
	  })*/
	
	  waboxapp.on('webhook', function (e) {
	    //preprocessEvent(e)
	    //.then(profile => {
	    // push the message to the incoming middleware
	    console.log(e);
	    bp.middlewares.sendIncoming({
	      platform: e.platform,
	      type: e.type,
	      text: e.text,
	      user: e.user,
	      raw: e.body
	    });
	    //})
	  });
	};

/***/ }),
/* 15 */
/***/ (function(module, exports) {

	module.exports = require("lru-cache");

/***/ }),
/* 16 */
/***/ (function(module, exports, __webpack_require__) {

	'use strict';
	
	var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();
	
	var _util = __webpack_require__(17);
	
	var _util2 = _interopRequireDefault(_util);
	
	var _lodash = __webpack_require__(5);
	
	var _lodash2 = _interopRequireDefault(_lodash);
	
	var _actions = __webpack_require__(12);
	
	var _actions2 = _interopRequireDefault(_actions);
	
	function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }
	
	function getUserId(event) {
	  var userId = _lodash2.default.get(event, 'raw.contact.uid') || _lodash2.default.get(event, 'raw.userId') || _lodash2.default.get(event, 'userId') || _lodash2.default.get(event, 'raw.from') || _lodash2.default.get(event, 'user.id') || _lodash2.default.get(event, 'raw.user.id');
	
	  if (!userId) {
	    throw new Error('Could not find userId in the incoming event.');
	  }
	
	  return userId;
	}
	
	function _processOutgoing(_ref) {
	  var event = _ref.event,
	      blocName = _ref.blocName,
	      instruction = _ref.instruction;
	
	  var ins = Object.assign({}, instruction); // Create a shallow copy of the instruction
	  ////////
	  // PRE-PROCESSING
	  ////////
	
	  var optionsList = ['quick_replies', 'waitRead', 'waitDelivery', 'typing', 'tag', '__platformSpecific', 'on'];
	
	  var options = _lodash2.default.pick(instruction, optionsList);
	
	  var _iteratorNormalCompletion = true;
	  var _didIteratorError = false;
	  var _iteratorError = undefined;
	
	  try {
	    for (var _iterator = optionsList[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
	      var prop = _step.value;
	
	      delete ins[prop];
	    }
	
	    /////////
	    /// Processing
	    /////////
	
	  } catch (err) {
	    _didIteratorError = true;
	    _iteratorError = err;
	  } finally {
	    try {
	      if (!_iteratorNormalCompletion && _iterator.return) {
	        _iterator.return();
	      }
	    } finally {
	      if (_didIteratorError) {
	        throw _iteratorError;
	      }
	    }
	  }
	
	  if (!_lodash2.default.isNil(instruction.text)) {
	    return _actions2.default.createText(getUserId(event), instruction.text, options);
	  }
	
	  ////////////
	  /// POST-PROCESSING
	  ////////////
	
	  // Nothing to post-process yet
	
	  ////////////
	  /// INVALID INSTRUCTION
	  ////////////
	
	  var strRep = _util2.default.inspect(instruction, false, 1);
	  throw new Error('Unrecognized instruction on Waboxapp Messenger in bloc \'' + blocName + '\': ' + strRep);
	}
	
	////////////
	/// TEMPLATES
	////////////
	
	function getTemplates() {
	  return [{
	    type: 'Text - Single message',
	    template: 'block_name_sm:\n\  - Text goes here..'
	  }];
	}
	
	module.exports = function (bp) {
	  var _$at = _lodash2.default.at(bp, ['umm', 'umm.registerConnector']),
	      _$at2 = _slicedToArray(_$at, 2),
	      umm = _$at2[0],
	      registerConnector = _$at2[1];
	
	  umm && registerConnector && registerConnector({
	    platform: 'waboxapp',
	    processOutgoing: function processOutgoing(args) {
	      return _processOutgoing(Object.assign({}, args, { bp: bp }));
	    },
	    templates: getTemplates()
	  });
	};

/***/ }),
/* 17 */
/***/ (function(module, exports) {

	module.exports = require("util");

/***/ }),
/* 18 */
/***/ (function(module, exports) {

	module.exports = "# Edit this file to set the Waboxapp's module settings programmatically instead of using the GUI\n# This is regular YAML syntax. See http://docs.ansible.com/ansible/YAMLSyntax.html\n# You can override these settings with ENV variables. They are commented below.\n\n# url: \"\" # HOST_URL\n\n# phoneID: \"\" # WABOXAPP_PHONE_ID\n# accessToken: \"\" # WABOXAPP_ACCESS_TOKEN\n\n\nenabled: true\n"

/***/ })
/******/ ]);
//# sourceMappingURL=node.bundle.js.map